function loadApp(data) {
  return new Vue({
    el: "#app",
    data: data,
    methods: {
      list_room: function () {
        var url = "https://" + data.host + ":" + data.port + "/flussonic/api/dynamic-mosaic/";
        var json = { command: "list_room" };
        json.args = [];
        fetch(url, {
          method: "post",
          credentials: "same-origin",
          headers: new Headers({ Authorization: "Basic Zmx1c3NvbmljOnBhc3M=" }),
          body: JSON.stringify(json),
        }).then(function (response) {
            response.json().then(function (json) {
              console.log(json);
              data.rooms = json.map(function(name) {
                      return {room:name, link: "/room.html?room="+name};
                });
              console.log(data.rooms);
            });
          });
      },
      add_room: function() {
        if(data.room == ""){
            console.log("empty room name!");
            return;
        }
        that = this;
        var url = "https://" + data.host + ":" + data.port + "/flussonic/api/dynamic-mosaic/";
        var json = { command: "add_room" };
        json.args = [data.room.split(' ').join('')];
        fetch(url, {
          method: "post",
          credentials: "same-origin",
          headers: new Headers({ Authorization: "Basic Zmx1c3NvbmljOnBhc3M=" }),
          body: JSON.stringify(json),
        }).then(function (responce) { that.list_room(); return responce.json();});
      }
    }
  }
  )};


